; 2600 for newbies
; Session 15 - More Playfield
;
; Exercise 2 - 	Using shadow ram with CTRLPF to change playfield color.
;		The following exercise draws a square playfield with
;		the top half using the playfield color. The bottom half
;		of the playfield uses player sprite colors.

	processor 6502
	include "vcs.h"
	include "macro.h"

	seg
	org $F000

CTRLPF_shadow = $82	; Variable will hold a copy of the value of CTRLPF.

Reset

 ldx #0
 lda #0

Clear			; Initialization

 sta 0,x
 inx
 bne Clear

 lda #$45
 sta COLUPF

 lda #$80		; NTSC blue for player 0
 sta COLUP0

 lda #$1E		; NTSC yellow for player 1
 sta COLUP1

 lda #%00000001		; Set both shadow copy and CTRLPF to "mirror" mode. 
 sta CTRLPF_shadow
 sta CTRLPF

StartOfFrame		; Beginning of scanline loop

 lda #0
 sta VBLANK

 lda #2
 sta VSYNC

 sta WSYNC
 sta WSYNC
 sta WSYNC

 lda #0
 sta VSYNC

 lda #%00000011		; set shadow copy to mirror mode and
 sta CTRLPF_shadow	; to use player prite colors. 

 ldx #0			; x counts the scanlines.

VerticalBlank

 sta WSYNC
 inx
 cpx #37
 bne VerticalBlank

 ldx #0

 lda #%11111111
 sta PF0
 sta PF1
 sta PF2

Top8Lines

 sta WSYNC
 inx
 cpx #8
 bne Top8Lines

 lda #%00010000
 sta PF0
 lda #0
 sta PF1
 sta PF2

MiddleLines

Alter1stTime

 cpx #96		; Wait until the 96th scanline (middle of screen) to...
 bne Continue

 lda CTRLPF_shadow	; Load shadow copy into real CTRLPF
 sta CTRLPF

 and #%11111101		; Clear SCORE bit in shadow copy of CTRLPF
 sta CTRLPF_shadow	; to use playfield color again. This won't be set
			; until the end of the scanline loop.

Continue

 sta WSYNC
 inx
 cpx #184
 bne MiddleLines

 lda #%11111111
 sta PF0
 sta PF1
 sta PF2

Bottom8Lines

 sta WSYNC
 inx
 cpx #192
 bne Bottom8Lines


 lda CTRLPF_shadow	; Set CTRLPF to use playfield color again.
 sta CTRLPF
 
 lda #%01000010
 sta VBLANK

 ldx #0

Overscan

 sta WSYNC
 inx
 cpx #30
 bne Overscan

 jmp StartOfFrame


	ORG $FFFA

InterruptVectors

	.word Reset 
	.word Reset 
	.word Reset 

 END

